# wind_sensor_helper.phy

from machine import I2C
from time import sleep
from ADS1115 import *

# Ustawienie zmiennej na adres ADS
ADS1115_ADDRESS = 0x48

i2c = I2C(0)
adc = ADS1115(ADS1115_ADDRESS, i2c=i2c)
adc.setVoltageRange_mV(ADS1115_RANGE_6144)	# 6144   
adc.setCompareChannels(ADS1115_COMP_0_GND)
adc.setMeasureMode(ADS1115_SINGLE)

# Funkcja odczytująca dane z kanału
def readChannel(channel):
    adc.setCompareChannels(channel)
    adc.startSingleMeasurement()
    while adc.isBusy():
        pass
    voltage = adc.getResult_V()
    return voltage

# Słownik wartości kierunku wiatru
values = {
        "N": 2.44,			#42
        #"NW": [2.78, 2.57],
        "NW1": 2.58,	# 
        "NW2": 2.8,
        "W": 3.01,			#0
        "SW": 1.8,		# 1.9 
        "S": 0.82,			#82
        "SE": 0.52,		# 0.4078  0.595
        "E": 0.26,			#26
        "NE": 1.35,		# 
        "NO": 0.1
    }


# Funkcja zwracjąca kierunek wiatru odczytanego z ADS
def get_wind_direction():
    # Napięcie rezystancyjnego czujnika deszczu
    rain_volt = round(readChannel(ADS1115_COMP_3_GND), 2)
    print("Rain_volt: ", rain_volt, "V")
    # Napięcie czujnika NTC
    temp_volt = round(readChannel(ADS1115_COMP_1_GND), 2)
    print("Temp_volt: ", temp_volt, "V")
    # Napięcie referencyjne
    ref_volt = round(readChannel(ADS1115_COMP_2_GND), 2)
    print("Ref_volt: ", ref_volt, "V")
    # Napięcie dzielnika kierunku wiatru
    voltage = round(readChannel(ADS1115_COMP_0_GND), 2)
    # Definiowanie wartości dla poszczególnych kierunków
    print("Wind Direction Voltage:", voltage, 'V')
    
    # Sprawdzenie wartości dla każdego kierunku
    if voltage < values["NO"]:
        return "No sensor"
    if voltage <= values["E"]:
        return "E"
    if voltage <= values["SE"]:
        return "SE"
    if voltage <= values["S"]:
        return "S"
    if voltage <= values["NE"]:
        return "NE"
    if voltage <= values["SW"]:
        return "SW"
    if voltage <= values["N"]:
        return "N"
    if voltage <= values["NW1"]:
        return "NW"
    if voltage <= values["NW2"]:
        return "NW"
    if voltage <= values["W"]:
        return "W"

        

